local debug
--[===[@debug@
debug = true
--@end-debug@]===]
local function dprint(...)
	if debug then
		print("[KM debug]",...)
	end
end

local memory = {}
local function increase(key) dprint('increase:',key) memory[key] = (memory[key] or 0) + 1 end
local function read(key) return (memory[key] or 0) end
local function total() local c=0 for k,i in pairs(memory) do if k ~= "announce" then c=c+i end end return c end
local function sortFunc(a,b) return a[2]>b[2] end
local eventFrame = CreateFrame("Frame")
local kmIDs = {[51124]=true,}
local obliterate = 49020
local frostStrike = 49143
local lastUse = 0
local killingMachine
local pGUID
local outputTable = {}
eventFrame:SetScript("OnEvent",function(self,event,t,subEvent,_,sourceGUID,_,_,_,destGUID,destName,_,_,spellID)
	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		pGUID = pGUID or UnitGUID("player")
		if sourceGUID == pGUID then
			if destName and destName:find("Training Dummy") then
				if not memory.announce then
					dprint('Hit training dummy, report this fight!')
				end
				memory.announce = true
			end
			if subEvent == "SPELL_CAST_SUCCESS" then
				if not killingMachine then
					killingMachine = GetSpellInfo((next(kmIDs)))
				end
				if UnitAura("player",killingMachine) then
					if spellID == obliterate then
						increase('obliterate')
						lastUse=t
					end
					if spellID == frostStrike then
						increase('froststrike')
						lastUse=t
					end
				end
			end
			if subEvent == "SPELL_AURA_REFRESH" then
				--print(spellID)
				if kmIDs[spellID] then
					increase('overwritten')
				end
			end
			if subEvent == "SPELL_AURA_REMOVED" then
				--print(spellID)
				if kmIDs[spellID] and ((t-3)>=lastUse) then
					increase('faded')
				end
			end
		end
	end
	if event == "PLAYER_REGEN_DISABLED" then
		table.wipe(memory)
	end
	if event == "PLAYER_REGEN_ENABLED" then
		if memory.announce then
			print("[|cffff00ffKillingMachine Analysis|r]")
			table.wipe(outputTable)
			tinsert(outputTable,{"KM procs used on Obliterate: %d [%.01d%%]",read('obliterate')})
			tinsert(outputTable,{"KM procs used on Frost Strike: %d [%.01d%%]",read('froststrike')})
			tinsert(outputTable,{"KM procs wasted: %d (%d expired, %d overwritten) [%.01d%%]",read('faded')+read('overwritten'),read('faded'),read('overwritten')})
			table.sort(outputTable,sortFunc)
			for _,data in ipairs(outputTable) do
				local t = total()
				tinsert(data,((data[2]/t)*100))
				print(string.format(unpack(data)))
			end
		end
	end
	if event == "INSTANCE_ENCOUNTER_ENGAGE_UNIT" then
		if UnitExists("boss1") or UnitExists("boss2") or UnitExists("boss3") or UnitExists("boss4") then
			if not memory.announce then
				dprint('Boss found, report this fight!')
			end
			memory.announce = true
		end
	end
end)
eventFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
eventFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
eventFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
eventFrame:RegisterEvent("INSTANCE_ENCOUNTER_ENGAGE_UNIT")